import { NextApiHandler } from 'next';
import { I as InternalMiddlewareMap, b as RouterMethod, N as NextApiHandlerWithMiddleware, c as AddMiddleware, T as TypedObject } from './constants-807f1ae6.js';
import './api-logger.js';

declare abstract class ExpressLikeRouter {
    protected readonly middlewareParallelListMap: InternalMiddlewareMap;
    protected readonly middlewareQueueMap: InternalMiddlewareMap;
    protected readonly routeHandlerMap: Partial<Record<RouterMethod, NextApiHandlerWithMiddleware<unknown, any>>>;
    readonly use: AddMiddleware<ExpressLikeRouter>;
    readonly inject: AddMiddleware<ExpressLikeRouter>;
    readonly get: <T, M extends TypedObject = TypedObject>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly patch: <T, M extends TypedObject = TypedObject>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly delete: <T, M extends TypedObject = TypedObject>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly post: <T, M extends TypedObject = TypedObject>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    readonly put: <T, M extends TypedObject = TypedObject>(handler: NextApiHandlerWithMiddleware<T, M>) => ExpressLikeRouter;
    abstract build(): NextApiHandler;
    private addMiddleware;
    private addOrSetPartialArrayMap;
    private addRouterMethod;
}

export { ExpressLikeRouter };
